(function() {
    //商品页面的配置参数
    try {
        if(pageConfig){
            var cache = [];
            var jsonStr = JSON.stringify(pageConfig, (key, value)=>{
                if (typeof value === 'object' && value !== null) {
                    if (cache.indexOf(value) !== -1) {return;}
                    cache.push(value);
                }
                return value;
            });
            cache = null;
            document.body.setAttribute('data-cfg', jsonStr);
        }
    } catch (error) { }
    // 活动页面的数据
    try {
        if(window.__react_data__){
            var cache = [];
            var jsonStr = JSON.stringify(window.__react_data__, (key, value)=>{
                if (typeof value === 'object' && value !== null) {
                    if (cache.indexOf(value) !== -1) {return;}
                    cache.push(value);
                }
                return value;
            });
            cache = null;
            document.body.setAttribute('data-cfg', jsonStr);
        }
    } catch (error) { }
    // 活动页面的数据
    try {
        if(window.sn){
            var cache = [];
            var jsonStr = JSON.stringify(window.sn, (key, value)=>{
                if (typeof value === 'object' && value !== null) {
                    if (cache.indexOf(value) !== -1) {return;}
                    cache.push(value);
                }
                return value;
            });
            cache = null;
            document.body.setAttribute('data-cfg', jsonStr);
        }
    } catch (error) { }
})();

(function(){
    const h5stObj = {};
    //console.log('insert H5st init', window)
    window.addEventListener("jtzsH5stMessage", async (event) => {
        //console.log('jtzsH5stMessage init', event, window)
        if(event.detail && (window.ParamsSignMain || window.ParamsSign)){
            //console.log('jtzsH5stMessage', event.detail, window)
            const {query, key, appId} = event.detail;
            if(query && key && appId){
                if(!(appId in h5stObj)){
                    const Cls = window.ParamsSignMain || window.ParamsSign;
                    const config = {
                        appId: appId,
                        debug: false,
                        preRequest: false,
                        onSign: function(_code) {
                            //console.log(_code)
                        },
                        onRequestTokenRemotely: function(_code, _message){
                            //console.log(_code, _message)
                        },
                        onRequestToken: function(_code, _message){
                            //console.log(_code, _message)
                        }
                    };

                    if(window.ParamsSignMain){
                        config["bucket"] = "0.1.8";
                    }
                    h5stObj[appId] = new Cls(config);
                }
                const result = await h5stObj[appId].sign(query);
                //console.log('jtzsH5stMessageResult_'+key,result)
                window.dispatchEvent(
                    new CustomEvent('jtzsH5stMessageResult_'+key, { detail: { result, key, appId } })
                );
            }
        }
    });

    window.addEventListener("jtzsPostMessage", async (event) => {
        //console.log('监听到jtzsPostMessage发送的消息', event)
        if(event?.detail){
            const {param, time} = event?.detail;
            const result = await window[param]
            window.dispatchEvent(new CustomEvent('jtzsPostMessageResult_'+time, { detail: { result: JSON.stringify(result), time } }));
        }
    });
})();

// 处理非标准JSON数据
(function(){
    window.addEventListener("jtzsHandleJson", async (event) => {
        const {key, data} = event.detail;

        var result = await eval('('+ data + ')');
        window.dispatchEvent(
            new CustomEvent("handleJsonResult_"+key, { detail: { data: result, key } })
        )
    })
})();